package com.huiju.welcome.service.impl;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.mapper.TaGoodsOrdersDetailMapper;
import com.huiju.welcome.mapper.TaGoodsOrdersMapper;
import com.huiju.welcome.mapper.TaMainUsherRecordMapper;
import com.huiju.welcome.model.TaGoodsOrders;
import com.huiju.welcome.model.TaGoodsOrdersDetail;
import com.huiju.welcome.service.ITaGoodsOrdersService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-07-16
 */
@Service
public class TaGoodsOrdersServiceImpl extends ServiceImpl<TaGoodsOrdersMapper, TaGoodsOrders> implements ITaGoodsOrdersService {
    @Autowired
    private TaGoodsOrdersMapper taGoodsOrdersMapper;
    @Autowired
    private TaGoodsOrdersDetailMapper taGoodsOrdersDetailMapper;
    @Autowired
    private TaMainUsherRecordMapper taMainUsherRecordMapper;

    @Override
    public ResponseBean goodsOrderList(IPage<TaGoodsOrders> pg, String userName,Integer userId,String ordersNo,Integer customerId) {
        ResponseBean responseBean= new ResponseBean();
        IPage<TaGoodsOrders> list= taGoodsOrdersMapper.goodsOrderList(pg,userName,userId,ordersNo,customerId);
        List<Integer> orderIds = new ArrayList<>();
        List<TaGoodsOrders> orders = list.getRecords();
        for(int i = 0;i<orders.size();i++){
            orderIds.add(orders.get(i).getOrdersId());
        }
        List<TaGoodsOrdersDetail>detailList = taGoodsOrdersDetailMapper.selectBatchIds(orderIds);
        for (int j = 0;j<orders.size();j++){
            List<TaGoodsOrdersDetail>thisDetail = new ArrayList<>();
            for(int h = 0; h<detailList.size();h++){
                if(orders.get(j).getOrdersId().equals(detailList.get(h).getOrdersId())){
                    thisDetail.add(detailList.get(h));
                }
            }
            orders.get(j).setDetailList(thisDetail);
        }
        responseBean.addSuccess(list);
        return responseBean;
    }
    @Override
    public Integer getRecIdByCustomerIdCurrentDate(Integer customerId){
        Integer recId = taMainUsherRecordMapper.getRecIdByCustomerIdCurrentDate(customerId);
        return recId;

    }
    @Override
    public ResponseBean getRecentOrder(Integer customerId){
        ResponseBean responseBean= new ResponseBean();
        TaGoodsOrders taGoodsOrders = taGoodsOrdersMapper.getRecentOrder(customerId);
        taGoodsOrders.setDetailList(taGoodsOrdersDetailMapper.detailList(taGoodsOrders.getOrdersId()));
        responseBean.addSuccess(taGoodsOrders);
        return responseBean;
    }

}
